/*@@
   @file    ML_CCZ4_Helper_Parameters.c
   @author  Automatically generated by CreateParameterBindings.pl
   @desc
            Creates/extends parameters for this thorn
   @enddesc
 @@*/


#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "cctk_Config.h"
#include "cctk_Constants.h"
#include "ParameterBindings.h"
#include "CParameterStructNames.h"
#include "ParameterCRestrictedADMBASE.h"
#include "ParameterCRestrictedBOUNDARY.h"
#include "ParameterCRestrictedGENERICFD.h"
#include "ParameterCRestrictedMETHODOFLINES.h"
#include "ParameterCRestrictedML_CCZ4.h"

/* structure containing all private parameters of thorn ML_CCZ4_Helper */
struct
{
  CCTK_INT ML_CCZ4_MaxNumConstrainedVars;
  /* All parameter blocks become common blocks in Fortran, and they should all
   * have the common attribute in C. */
} PRIVATE_ML_CCZ4_HELPER_STRUCT CCTK_ATTRIBUTE_COMMON;


/* structure containing all restricted parameters of thorn ML_CCZ4_Helper */
struct
{
  int dummy_parameter;
  /* All parameter blocks become common blocks in Fortran, and they should all
   * have the common attribute in C. */
} RESTRICTED_ML_CCZ4_HELPER_STRUCT CCTK_ATTRIBUTE_COMMON;


int CCTKi_BindingsCreateML_CCZ4_HelperParameters(void);
int CCTKi_BindingsCreateML_CCZ4_HelperParameters(void)
{
  CCTKi_ParameterCreate("ML_CCZ4_MaxNumConstrainedVars",
                        "ML_CCZ4_Helper",
                        "INT",
                        "PRIVATE",
                        CCTK_STEERABLE_NEVER,
                        "Number of constrained variables used by this thorn",
                        "20",
                        &(PRIVATE_ML_CCZ4_HELPER_STRUCT.ML_CCZ4_MaxNumConstrainedVars),
                        0,
                        NULL,
                        1,
                        "20:20","Number of constrained variables used by this thorn");

  return 0;
}

int CCTKi_BindingsML_CCZ4_HelperParameterExtensions(void);
int CCTKi_BindingsML_CCZ4_HelperParameterExtensions(void)
{
  CCTKi_ParameterAddRange("ML_CCZ4",
                          "my_initial_boundary_condition",
                          "ML_CCZ4_Helper",
                          "extrapolate-gammas",
                         "extrapolate-gammas");

  CCTKi_ParameterAddRange("ML_CCZ4",
                          "my_rhs_boundary_condition",
                          "ML_CCZ4_Helper",
                          "NewRad",
                         "NewRad");

  CCTKi_ParameterAddRange("ML_CCZ4",
                          "initial_boundary_condition",
                          "ML_CCZ4_Helper",
                          "extrapolate-gammas",
                         "extrapolate-gammas");

  CCTKi_ParameterAddRange("ML_CCZ4",
                          "rhs_boundary_condition",
                          "ML_CCZ4_Helper",
                          "NewRad",
                         "NewRad");

  CCTKi_ParameterAccumulatorBase("ML_CCZ4_Helper",
                          "ML_CCZ4_MaxNumConstrainedVars",
                          "MethodofLines",
                          "MoL_Num_Constrained_Vars");

  return 0;
}
