/*@@
   @file    ShiftedGaugeWave_Parameters.c
   @author  Automatically generated by CreateParameterBindings.pl
   @desc
            Creates/extends parameters for this thorn
   @enddesc
 @@*/


#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "cctk_Config.h"
#include "cctk_Constants.h"
#include "ParameterBindings.h"
#include "CParameterStructNames.h"
#include "ParameterCRestrictedADMBASE.h"
#include "ParameterCRestrictedGENERICFD.h"
#include "ParameterCRestrictedMETHODOFLINES.h"

/* structure containing all private parameters of thorn ShiftedGaugeWave */
struct
{
  const char * exact_method;
  /* All parameter blocks become common blocks in Fortran, and they should all
   * have the common attribute in C. */
} PRIVATE_SHIFTEDGAUGEWAVE_STRUCT CCTK_ATTRIBUTE_COMMON;


/* structure containing all restricted parameters of thorn ShiftedGaugeWave */
struct
{
  CCTK_REAL amp;
  CCTK_REAL boostx;
  CCTK_REAL boosty;
  CCTK_REAL boostz;
  CCTK_REAL lapsefactor;
  CCTK_REAL period;
  CCTK_REAL phi;
  CCTK_REAL positionx;
  CCTK_REAL positiony;
  CCTK_REAL positionz;
  CCTK_REAL psi;
  CCTK_REAL shiftaddx;
  CCTK_REAL shiftaddy;
  CCTK_REAL shiftaddz;
  CCTK_REAL theta;
  CCTK_REAL timeoffset;
  CCTK_INT ShiftedGaugeWave_MaxNumArrayEvolvedVars;
  CCTK_INT ShiftedGaugeWave_MaxNumEvolvedVars;
  CCTK_INT ShiftedGaugeWave_always_calc_every;
  CCTK_INT ShiftedGaugeWave_always_calc_offset;
  CCTK_INT ShiftedGaugeWave_exact_calc_every;
  CCTK_INT ShiftedGaugeWave_exact_calc_offset;
  CCTK_INT ShiftedGaugeWave_initial_calc_every;
  CCTK_INT ShiftedGaugeWave_initial_calc_offset;
  CCTK_INT other_timelevels;
  CCTK_INT rhs_timelevels;
  CCTK_INT tile_size;
  CCTK_INT timelevels;
  CCTK_INT verbose;
  /* All parameter blocks become common blocks in Fortran, and they should all
   * have the common attribute in C. */
} RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT CCTK_ATTRIBUTE_COMMON;


int CCTKi_BindingsCreateShiftedGaugeWaveParameters(void);
int CCTKi_BindingsCreateShiftedGaugeWaveParameters(void)
{
  CCTKi_ParameterCreate("ShiftedGaugeWave_MaxNumArrayEvolvedVars",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_RECOVER,
                        "Number of Array evolved variables used by this thorn",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_MaxNumArrayEvolvedVars),
                        0,
                        NULL,
                        1,
                        "0:0","Number of Array evolved variables used by this thorn");

  CCTKi_ParameterCreate("ShiftedGaugeWave_MaxNumEvolvedVars",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_RECOVER,
                        "Number of evolved variables used by this thorn",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_MaxNumEvolvedVars),
                        0,
                        NULL,
                        1,
                        "0:0","Number of evolved variables used by this thorn");

  CCTKi_ParameterCreate("ShiftedGaugeWave_always_calc_every",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "ShiftedGaugeWave_always_calc_every",
                        "1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_always_calc_every),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("ShiftedGaugeWave_always_calc_offset",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "ShiftedGaugeWave_always_calc_offset",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_always_calc_offset),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("ShiftedGaugeWave_exact_calc_every",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "ShiftedGaugeWave_exact_calc_every",
                        "1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_exact_calc_every),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("ShiftedGaugeWave_exact_calc_offset",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "ShiftedGaugeWave_exact_calc_offset",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_exact_calc_offset),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("ShiftedGaugeWave_initial_calc_every",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "ShiftedGaugeWave_initial_calc_every",
                        "1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_initial_calc_every),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("ShiftedGaugeWave_initial_calc_offset",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "ShiftedGaugeWave_initial_calc_offset",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.ShiftedGaugeWave_initial_calc_offset),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("amp",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "amp",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.amp),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("boostx",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "boostx",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.boostx),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("boosty",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "boosty",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.boosty),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("boostz",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "boostz",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.boostz),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("lapsefactor",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "lapsefactor",
                        "1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.lapsefactor),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("other_timelevels",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_RECOVER,
                        "Number of active timelevels for non-evolved grid functions",
                        "1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.other_timelevels),
                        0,
                        NULL,
                        1,
                        "0:3","");

  CCTKi_ParameterCreate("period",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "period",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.period),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("phi",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "phi",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.phi),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("positionx",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "positionx",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.positionx),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("positiony",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "positiony",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.positiony),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("positionz",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "positionz",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.positionz),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("psi",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "psi",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.psi),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("rhs_timelevels",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_RECOVER,
                        "Number of active RHS timelevels",
                        "1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.rhs_timelevels),
                        0,
                        NULL,
                        1,
                        "0:3","");

  CCTKi_ParameterCreate("shiftaddx",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "shiftaddx",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.shiftaddx),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("shiftaddy",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "shiftaddy",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.shiftaddy),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("shiftaddz",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "shiftaddz",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.shiftaddz),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("theta",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "theta",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.theta),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("tile_size",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "Loop tile size",
                        "-1",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.tile_size),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("timelevels",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_RECOVER,
                        "Number of active timelevels",
                        "3",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.timelevels),
                        0,
                        NULL,
                        1,
                        "0:3","");

  CCTKi_ParameterCreate("timeoffset",
                        "ShiftedGaugeWave",
                        "REAL",
                        "RESTRICTED",
                        CCTK_STEERABLE_NEVER,
                        "timeoffset",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.timeoffset),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("verbose",
                        "ShiftedGaugeWave",
                        "INT",
                        "RESTRICTED",
                        CCTK_STEERABLE_ALWAYS,
                        "verbose",
                        "0",
                        &(RESTRICTED_SHIFTEDGAUGEWAVE_STRUCT.verbose),
                        0,
                        NULL,
                        1,
                        "*:*","");

  CCTKi_ParameterCreate("exact_method",
                        "ShiftedGaugeWave",
                        "KEYWORD",
                        "PRIVATE",
                        CCTK_STEERABLE_NEVER,
                        "exact_method",
                        "none",
                        &(PRIVATE_SHIFTEDGAUGEWAVE_STRUCT.exact_method),
                        0,
                        NULL,
                        2,
                        "none","",
                        "ShiftedGaugeWave","");

  return 0;
}

int CCTKi_BindingsShiftedGaugeWaveParameterExtensions(void);
int CCTKi_BindingsShiftedGaugeWaveParameterExtensions(void)
{
  CCTKi_ParameterAddRange("ADMBASE",
                          "initial_data",
                          "ShiftedGaugeWave",
                          "ShiftedGaugeWave",
                         "");

  CCTKi_ParameterAddRange("ADMBASE",
                          "initial_lapse",
                          "ShiftedGaugeWave",
                          "ShiftedGaugeWave",
                         "");

  CCTKi_ParameterAddRange("ADMBASE",
                          "initial_shift",
                          "ShiftedGaugeWave",
                          "ShiftedGaugeWave",
                         "");

  CCTKi_ParameterAddRange("ADMBASE",
                          "initial_dtlapse",
                          "ShiftedGaugeWave",
                          "ShiftedGaugeWave",
                         "");

  CCTKi_ParameterAddRange("ADMBASE",
                          "initial_dtshift",
                          "ShiftedGaugeWave",
                          "ShiftedGaugeWave",
                         "");

  CCTKi_ParameterAddRange("ADMBASE",
                          "evolution_method",
                          "ShiftedGaugeWave",
                          "ShiftedGaugeWave",
                         "");

  CCTKi_ParameterAccumulatorBase("ShiftedGaugeWave",
                          "ShiftedGaugeWave_MaxNumArrayEvolvedVars",
                          "MethodofLines",
                          "MoL_Num_ArrayEvolved_Vars");

  CCTKi_ParameterAccumulatorBase("ShiftedGaugeWave",
                          "ShiftedGaugeWave_MaxNumEvolvedVars",
                          "MethodofLines",
                          "MoL_Num_Evolved_Vars");

  return 0;
}
