/*@@
   @file       ScheduleCactus.c
   @author     Automatically generated by CreateScheduleBindings.pl
   @desc
               Creates the schedule and parameter recovery bindings 
               for thorn Cactus
   @enddesc
@@*/


#include "Cactus/cctk.h"
#include "Cactus/CParameters.h"
#include "cctki_ScheduleBindings.h"
#include "Cactus/cctk_ScheduleFunctions.h"

/* Prototypes for Fortran schedule bindings functions to be registered */
/* Note that this is a cheat, we just need a function pointer. */


void CCTKi_BindingsSchedule_Cactus(void);
void CCTKi_BindingsSchedule_Cactus(void)
{
  DECLARE_CCTK_PARAMETERS
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_RECOVER_PARAMETERS",
"CCTK_RECOVER_PARAMETERS",
                        "Cactus",
                        "Cactus",
                        "Used by thorns with relevant I/O methods as the point to read parameters",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_STARTUP",
"CCTK_STARTUP",
                        "Cactus",
                        "Cactus",
                        "Run before any grids are constructed.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_WRAGH",
"CCTK_WRAGH",
                        "Cactus",
                        "Cactus",
                        "This timebin is executed when all parameters are known, but before the driver thorn constructs the grid.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_PARAMCHECK",
"CCTK_PARAMCHECK",
                        "Cactus",
                        "Cactus",
                        "This timebin is for thorns to check the validity of parameter combinations.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_PREREGRIDINITIAL",
"CCTK_PREREGRIDINITIAL",
                        "Cactus",
                        "Cactus",
                        "This bin is executed to construct the initial grid hierarchy during the INITIAL bin.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTREGRIDINITIAL",
"CCTK_POSTREGRIDINITIAL",
                        "Cactus",
                        "Cactus",
                        "This bin is executed whenever the grid hierarchy or patch setup has changed during evolution; see CCTK_POSTREGRIDINITIAL.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_BASEGRID",
"CCTK_BASEGRID",
                        "Cactus",
                        "Cactus",
                        "This timebin is executed very early after a driver thorn constructs grid.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_INITIAL",
"CCTK_INITIAL",
                        "Cactus",
                        "Cactus",
                        "This is the place to set up any required initial data.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTINITIAL",
"CCTK_POSTINITIAL",
                        "Cactus",
                        "Cactus",
                        "This is the place to modify initial data, or to calculate data that depend on the initial data.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTRESTRICTINITIAL",
"CCTK_POSTRESTRICTINITIAL",
                        "Cactus",
                        "Cactus",
                        "This bin is executed after each restriction operation while initial data are set up; compare CCTK_POSTRESTRICT.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTPOSTINITIAL",
"CCTK_POSTPOSTINITIAL",
                        "Cactus",
                        "Cactus",
                        "This is the place to modify initial data, or to calculate data that depend on the initial data.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_RECOVER_VARIABLES",
"CCTK_RECOVER_VARIABLES",
                        "Cactus",
                        "Cactus",
                        "Used by thorns with relevant I/O methods as the point to read in all the grid variables when recovering from checkpoint files.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POST_RECOVER_VARIABLES",
"CCTK_POST_RECOVER_VARIABLES",
                        "Cactus",
                        "Cactus",
                        "This timebin exists for scheduling any functions which need to modify grid variables after recovery.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_CPINITIAL",
"CCTK_CPINITIAL",
                        "Cactus",
                        "Cactus",
                        "Used by thorns with relevant I/O methods as the point to checkpoint initial data if required.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_CHECKPOINT",
"CCTK_CHECKPOINT",
                        "Cactus",
                        "Cactus",
                        "Used by thorns with relevant I/O methods as the point to checkpoint data during the iterative loop when required.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_PREREGRID",
"CCTK_PREREGRID",
                        "Cactus",
                        "Cactus",
                        "his bin is executed whenever the grid hierarchy is about to change during evolution; compare CCTK_PREREGRIDINITIAL.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTREGRID",
"CCTK_POSTREGRID",
                        "Cactus",
                        "Cactus",
                        "This bin is executed whenever the grid hierarchy or patch setup has changed during evolution; see CCTK_POSTREGRIDINITIAL.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_PRESTEP",
"CCTK_PRESTEP",
                        "Cactus",
                        "Cactus",
                        "The timebin for scheduling any routines which need to be executed before any routines in the main evolution step.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_EVOL",
"CCTK_EVOL",
                        "Cactus",
                        "Cactus",
                        "The timebin for the main evolution step.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTRESTRICT",
"CCTK_POSTRESTRICT",
                        "Cactus",
                        "Cactus",
                        "This bin is executed after each restriction operation during evolution; compare CCTK_POSTRESTRICTINITIAL.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_POSTSTEP",
"CCTK_POSTSTEP",
                        "Cactus",
                        "Cactus",
                        "The timebin for scheduling any routines which need to be executed after all the routines in the main evolution step.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_ANALYSIS",
"CCTK_ANALYSIS",
                        "Cactus",
                        "Cactus",
                        "Routines which perform analysis should be independent of the main evolution loop",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_TERMINATE",
"CCTK_TERMINATE",
                        "Cactus",
                        "Cactus",
                        "Called after the main iteration loop when Cactus terminates.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("CCTK_SHUTDOWN",
"CCTK_SHUTDOWN",
                        "Cactus",
                        "Cactus",
                        "Cactus final shutdown routines, after the grid hierarchy has been destroyed.",
                        "",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
}

/*@@
  @routine    CCTKi_BindingsParameterRecovery_Cactus
  @author     Automatically generated by CreateScheduleBindings.pl
  @desc
              Creates the parameter recovery bindings for thorn Cactus
  @enddesc
@@*/

int CCTKi_BindingsParameterRecovery_Cactus(void);
int CCTKi_BindingsParameterRecovery_Cactus(void)
{
  /* this thorn doesn't define any parameter recovery routines */
  return (0);
}
