/*@@
   @file       ScheduleCartGrid3D.c
   @author     Automatically generated by CreateScheduleBindings.pl
   @desc
               Creates the schedule and parameter recovery bindings 
               for thorn CartGrid3D
   @enddesc
@@*/


#include "CartGrid3D/cctk.h"
#include "CartGrid3D/CParameters.h"
#include "cctki_ScheduleBindings.h"
#include "CartGrid3D/cctk_ScheduleFunctions.h"

/* Prototypes for Fortran schedule bindings functions to be registered */
/* Note that this is a cheat, we just need a function pointer. */


void CCTKi_BindingsSchedule_CartGrid3D(void);
void CCTKi_BindingsSchedule_CartGrid3D(void)
{
  DECLARE_CCTK_PARAMETERS
  if(!(1 >= 0 && 1  <= CCTK_DeclaredTimeLevels("grid::coordinates")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)1, "grid::coordinates", CCTK_DeclaredTimeLevels("grid::coordinates"));
  if(!(1 >= 0 && 1  <= CCTK_DeclaredTimeLevels("grid::gridspacings")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)1, "grid::gridspacings", CCTK_DeclaredTimeLevels("grid::gridspacings"));
  CCTKi_ScheduleGroupStorage("grid::coordinates",1);
  CCTKi_ScheduleGroupStorage("grid::gridspacings",1);
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)SymmetryStartup,
                           "SymmetryStartup",
                           "CartGrid3D",
                           "grid",
                           "Register GH Extension for GridSymmetry",
                           "CCTK_STARTUP",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)RegisterCartGrid3DCoords,
                           "RegisterCartGrid3DCoords",
                           "CartGrid3D",
                           "grid",
                           "Register coordinates for the Cartesian grid",
                           "CCTK_WRAGH",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_RegisterSymmetryBoundaries,
                           "CartGrid3D_RegisterSymmetryBoundaries",
                           "CartGrid3D",
                           "grid",
                           "Register symmetry boundaries",
                           "SymmetryRegister",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ParamCheck_CartGrid3D,
                           "ParamCheck_CartGrid3D",
                           "CartGrid3D",
                           "grid",
                           "Check coordinates for CartGrid3D",
                           "CCTK_PARAMCHECK",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "");
  }
if (CCTK_EQUALS (set_coordinate_ranges_on, "all grids"))
{
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_SetRanges,
                           "SpatialSpacings",
                           "CartGrid3D",
                           "grid",
                           "Set up ranges for spatial 3D Cartesian coordinates (on all grids)",
                           "CCTK_BASEGRID",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           1, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           1, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "grid::gridspacings(everywhere)"
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "",
                           "SpatialCoordinates");
  }
}
else if (CCTK_EQUALS (set_coordinate_ranges_on, "all maps"))
{
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_SetRanges,
                           "SpatialSpacings",
                           "CartGrid3D",
                           "grid",
                           "Set up ranges for spatial 3D Cartesian coordinates (on all maps)",
                           "CCTK_BASEGRID",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           1, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           1, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "grid::gridspacings(everywhere)"
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "singlemap",
                           "",
                           "SpatialCoordinates");
  }
}
else if (CCTK_EQUALS (set_coordinate_ranges_on, "first level"))
{
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_SetRanges,
                           "SpatialSpacings",
                           "CartGrid3D",
                           "grid",
                           "Set up ranges for spatial 3D Cartesian coordinates (on first level)",
                           "CCTK_BASEGRID",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           1, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           1, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/,
                           "grid::gridspacings(everywhere)"
                           /*==inval==*/
                           /*==opts==*/,
                           "level",
                           "",
                           "SpatialCoordinates");
  }
}
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_SetCoordinates,
                           "SpatialCoordinates",
                           "CartGrid3D",
                           "grid",
                           "Set up spatial 3D Cartesian coordinates on the GH",
                           "CCTK_BASEGRID",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           1, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "grid::coordinates(everywhere)"
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_SetCoordinates,
                           "SpatialCoordinates",
                           "CartGrid3D",
                           "grid",
                           "Set Coordinates after regridding",
                           "CCTK_POSTREGRIDINITIAL",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           1, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "grid::coordinates(everywhere)"
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_SetCoordinates,
                           "SpatialCoordinates",
                           "CartGrid3D",
                           "grid",
                           "Set Coordinates after regridding",
                           "CCTK_POSTREGRID",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           1, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "grid::coordinates(Everywhere)"
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)CartGrid3D_ApplyBC,
                           "CartGrid3D_ApplyBC",
                           "CartGrid3D",
                           "grid",
                           "Apply symmetry boundary conditions",
                           "BoundaryConditions",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "");
  }
}

/*@@
  @routine    CCTKi_BindingsParameterRecovery_CartGrid3D
  @author     Automatically generated by CreateScheduleBindings.pl
  @desc
              Creates the parameter recovery bindings for thorn CartGrid3D
  @enddesc
@@*/

int CCTKi_BindingsParameterRecovery_CartGrid3D(void);
int CCTKi_BindingsParameterRecovery_CartGrid3D(void)
{
  /* this thorn doesn't define any parameter recovery routines */
  return (0);
}
