/*@@
   @file       ScheduleML_CCZ4_Helper.c
   @author     Automatically generated by CreateScheduleBindings.pl
   @desc
               Creates the schedule and parameter recovery bindings 
               for thorn ML_CCZ4_Helper
   @enddesc
@@*/


#include "ML_CCZ4_Helper/cctk.h"
#include "ML_CCZ4_Helper/CParameters.h"
#include "cctki_ScheduleBindings.h"
#include "ML_CCZ4_Helper/cctk_ScheduleFunctions.h"

/* Prototypes for Fortran schedule bindings functions to be registered */
/* Note that this is a cheat, we just need a function pointer. */


void CCTKi_BindingsSchedule_ML_CCZ4_Helper(void);
void CCTKi_BindingsSchedule_ML_CCZ4_Helper(void)
{
  DECLARE_CCTK_PARAMETERS
if (CCTK_EQUALS(evolution_method, "ML_CCZ4"))
{
  if(!(timelevels >= 0 && timelevels  <= CCTK_DeclaredTimeLevels("ADMBase::metric")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)timelevels, "ADMBase::metric", CCTK_DeclaredTimeLevels("ADMBase::metric"));
  CCTKi_ScheduleGroupStorage("ADMBase::metric",timelevels);
  if(!(timelevels >= 0 && timelevels  <= CCTK_DeclaredTimeLevels("ADMBase::curv")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)timelevels, "ADMBase::curv", CCTK_DeclaredTimeLevels("ADMBase::curv"));
  CCTKi_ScheduleGroupStorage("ADMBase::curv",timelevels);
  if(!(timelevels >= 0 && timelevels  <= CCTK_DeclaredTimeLevels("ADMBase::lapse")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)timelevels, "ADMBase::lapse", CCTK_DeclaredTimeLevels("ADMBase::lapse"));
  CCTKi_ScheduleGroupStorage("ADMBase::lapse",timelevels);
  if(!(timelevels >= 0 && timelevels  <= CCTK_DeclaredTimeLevels("ADMBase::shift")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)timelevels, "ADMBase::shift", CCTK_DeclaredTimeLevels("ADMBase::shift"));
  CCTKi_ScheduleGroupStorage("ADMBase::shift",timelevels);
  if(!(timelevels >= 0 && timelevels  <= CCTK_DeclaredTimeLevels("ADMBase::dtlapse")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)timelevels, "ADMBase::dtlapse", CCTK_DeclaredTimeLevels("ADMBase::dtlapse"));
  CCTKi_ScheduleGroupStorage("ADMBase::dtlapse",timelevels);
  if(!(timelevels >= 0 && timelevels  <= CCTK_DeclaredTimeLevels("ADMBase::dtshift")))
      CCTK_VWarn(0, __LINE__, __FILE__, CCTK_THORNSTRING,
                 "Tried to schedule %ld timelevels for group '%s' in schedule.ccl.\n"
                 "Value must be between 0 and %d (inclusive)",
                 (long)timelevels, "ADMBase::dtshift", CCTK_DeclaredTimeLevels("ADMBase::dtshift"));
  CCTKi_ScheduleGroupStorage("ADMBase::dtshift",timelevels);
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_RegisterSlicing,
                           "ML_CCZ4_RegisterSlicing",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Register slicing",
                           "CCTK_STARTUP",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_SetGroupTags,
                           "ML_CCZ4_SetGroupTags",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Set checkpointing and prolongation group tags",
                           "CCTK_STARTUP",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           1, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "",
                           "Driver_Startup");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_ParamCompat,
                           "ML_CCZ4_ParamCompat",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Handle parameter backward compatibility",
                           "CCTK_WRAGH",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_ParamCheck,
                           "ML_CCZ4_ParamCheck",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Check parameters",
                           "CCTK_PARAMCHECK",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_RegisterConstrained,
                           "ML_CCZ4_RegisterConstrained",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Register ADMBase variables as constrained",
                           "MoL_Register",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           0, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "meta",
                           "");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("ML_CCZ4_EvolutionAnalysis",
"ML_CCZ4_EvolutionAnalysis",
                        "ML_CCZ4_Helper",
                        "ML_CCZ4_Helper",
                        "Calculate RHS at analysis",
                        "CCTK_ANALYSIS",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        7,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        0, /* Number of BEFORE   routines  */
                        0, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/,
                        "ML_CCZ4::ML_log_confacrhs",
                        "ML_CCZ4::ML_metricrhs",
                        "ML_CCZ4::ML_Gammarhs",
                        "ML_CCZ4::ML_trace_curvrhs",
                        "ML_CCZ4::ML_curvrhs",
                        "ML_CCZ4::ML_lapserhs",
                        "ML_CCZ4::ML_shiftrhs"
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "");
  }
if (CCTK_EQUALS(initial_boundary_condition, "extrapolate-gammas") ||
      CCTK_EQUALS(my_initial_boundary_condition, "extrapolate-gammas"))
{
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_ExtrapolateGammas,
                           "ML_CCZ4_ExtrapolateGammas",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Extrapolate Gammas and time derivatives of lapse and shift",
                           "CCTK_INITIAL",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           1, /* Number of WRITES clauses     */
                           1, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           1, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "ML_CCZ4::ML_Gamma(boundary)"
                           /*==reads==*/,
                           "ML_CCZ4::ML_Gamma(interior)"
                           /*==inval==*/
                           /*==opts==*/,
                           "",
                           "ML_CCZ4_InitialADMBase2Interior");
  }
}
if (CCTK_EQUALS(rhs_boundary_condition, "NewRad") ||
      CCTK_EQUALS(my_rhs_boundary_condition, "NewRad"))
{
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_NewRad,
                           "ML_CCZ4_NewRad",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Apply NewRad boundary conditions to RHS",
                           "MoL_CalcRHS",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           7, /* Number of WRITES clauses     */
                           7, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           1, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "ML_CCZ4::ML_Gammarhs(boundary)",
                           "ML_CCZ4::ML_curvrhs(boundary)",
                           "ML_CCZ4::ML_lapserhs(boundary)",
                           "ML_CCZ4::ML_metricrhs(boundary)",
                           "ML_CCZ4::ML_shiftrhs(boundary)",
                           "ML_CCZ4::phirhs(boundary)",
                           "ML_CCZ4::trKrhs(boundary)"
                           /*==reads==*/,
                           "ML_CCZ4::ML_Gamma(interior)",
                           "ML_CCZ4::ML_curv(interior)",
                           "ML_CCZ4::ML_lapse(interior)",
                           "ML_CCZ4::ML_metric(interior)",
                           "ML_CCZ4::ML_shift(interior)",
                           "ML_CCZ4::phi(interior)",
                           "ML_CCZ4::trK(interior)"
                           /*==inval==*/
                           /*==opts==*/,
                           "",
                           "ML_CCZ4_EvolutionInterior");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_NewRad,
                           "ML_CCZ4_NewRad",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Apply NewRad boundary conditions to RHS",
                           "ML_CCZ4_EvolutionAnalysis",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           7, /* Number of WRITES clauses     */
                           7, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           0, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           1, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/,
                           "ML_CCZ4::ML_Gammarhs(boundary)",
                           "ML_CCZ4::ML_curvrhs(boundary)",
                           "ML_CCZ4::ML_lapserhs(boundary)",
                           "ML_CCZ4::ML_metricrhs(boundary)",
                           "ML_CCZ4::ML_shiftrhs(boundary)",
                           "ML_CCZ4::phirhs(boundary)",
                           "ML_CCZ4::trKrhs(boundary)"
                           /*==reads==*/,
                           "ML_CCZ4::ML_Gamma(interior)",
                           "ML_CCZ4::ML_curv(interior)",
                           "ML_CCZ4::ML_lapse(interior)",
                           "ML_CCZ4::ML_metric(interior)",
                           "ML_CCZ4::ML_shift(interior)",
                           "ML_CCZ4::phi(interior)",
                           "ML_CCZ4::trK(interior)"
                           /*==inval==*/
                           /*==opts==*/,
                           "",
                           "ML_CCZ4_EvolutionAnalysisInterior");
  }
}
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleFunction((void *)ML_CCZ4_ADMBase_SelectBCs,
                           "ML_CCZ4_ADMBase_SelectBCs",
                           "ML_CCZ4_Helper",
                           "ML_CCZ4_Helper",
                           "Select boundary conditions for ADMBase variables",
                           "MoL_PostStep",
                           "C",
                           0,  /* Number of STORAGE  groups   */
                           0,  /* Number of COMM     groups   */
                           0,  /* Number of TRIGGERS groups   */
                           0, /* Number of SYNC     groups    */
                           0, /* Number of WRITES clauses     */
                           0, /* Number of READS clauses      */
                           0, /* Number of INVALIDATES clauses */
                           1, /* Number of Options            */
                           0, /* Number of BEFORE   routines  */
                           3, /* Number of AFTER    routines  */
                           0, /* Number of WHILE    variables */
                           0, /* Number of IF       variables */
                           cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                           /*==mem==*/
                           /*==comm==*/
                           /*==trigger==*/
                           /*==sync==*/
                           /*==writes==*/
                           /*==reads==*/
                           /*==inval==*/
                           /*==opts==*/,
                           "level",
                           "",
                           "ML_CCZ4_ADMBaseEverywhere",
                           "ML_CCZ4_ADMBaseInterior",
                           "ML_CCZ4_ADMBaseBoundaryScalar");
  }
  {
    int cctkschedulei_tlevelarray[] = {0};
    CCTKi_ScheduleGroup("ApplyBCs",
"ML_CCZ4_ADMBase_ApplyBCs",
                        "ML_CCZ4_Helper",
                        "ML_CCZ4_Helper",
                        "Apply boundary conditions to ADMBase variables",
                        "MoL_PostStep",
                        0,  /* Number of STORAGE  groups   */
                        0,  /* Number of COMM     groups   */
                        0,  /* Number of TRIGGERS groups   */
                        0, /* Number of SYNC     groups    */
                        0, /* Number of WRITES clauses     */
                        0, /* Number of READS clauses      */
                        0, /* Number of INVALIDATES clauses */
                        0, /* Number of Options            */
                        1, /* Number of BEFORE   routines  */
                        1, /* Number of AFTER    routines  */
                        0, /* Number of WHILE    variables */
                        0, /* Number of IF       variables */
                        cctkschedulei_tlevelarray  /* Array of timelevel data for storage groups */
                        /*==mem==*/
                        /*==comm==*/
                        /*==trigger==*/
                        /*==sync==*/
                        /*==writes==*/
                        /*==reads==*/
                        /*==inval==*/
                        /*==opts==*/,
                        "",
                        "ADMBase_SetADMVars",
                        "ML_CCZ4_ADMBase_SelectBCs");
  }
}
}

/*@@
  @routine    CCTKi_BindingsParameterRecovery_ML_CCZ4_Helper
  @author     Automatically generated by CreateScheduleBindings.pl
  @desc
              Creates the parameter recovery bindings for thorn ML_CCZ4_Helper
  @enddesc
@@*/

int CCTKi_BindingsParameterRecovery_ML_CCZ4_Helper(void);
int CCTKi_BindingsParameterRecovery_ML_CCZ4_Helper(void)
{
  /* this thorn doesn't define any parameter recovery routines */
  return (0);
}
