/*@@
   @file    GenericFD.c
   @author  Automatically generated by GridFuncStuff.pl
   @desc
            Creates the CCTK variables for thorn GenericFD
   @enddesc
 @@*/



#include <stddef.h>

#include "GenericFD/cctk.h"
#include "GenericFD/cctk_Arguments.h"
#include "cctk_Parameter.h"
#include "cctk_WarnLevel.h"
#include "cctki_Groups.h"
#include "cctki_FortranWrappers.h"
#include "GenericFD/cctk_ScheduleFunctions.h"

struct CCTK_JOIN_TOKENS(CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN), _struct) CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN);

int CactusBindingsVariables_GenericFD_Initialise(void);
int CactusBindingsVarIndex_GenericFD_Initialise(void);
static int CCTKi_BindingsFortranWrapperGenericFD(void *_GH, void *fpointer);

static int CCTKi_BindingsFortranWrapperGenericFD(void *_GH, void *fpointer)
{
  cGH const *const GH = _GH;
  const int _cctk_zero = 0;
  void (*function)(GENERICFD_C2F_PROTO);
  DECLARE_GENERICFD_C2F
  INITIALISE_GENERICFD_C2F
  (void) (_cctk_zero + 0);

  function = (void (*) (GENERICFD_C2F_PROTO)) fpointer;
  function (PASS_GENERICFD_C2F (GH));

  return (0);
}

int CactusBindingsVariables_GenericFD_Initialise(void)
{
  const char * warn_mixeddim_gfs = "";
  int warn_mixeddim = 0;
  const CCTK_INT *allow_mixeddim_gfs;


  allow_mixeddim_gfs = CCTK_ParameterGet ("allow_mixeddim_gfs", "Cactus", 0);



  if (CCTKi_CreateGroup ("JACOBIAN", "GENERICFD", "GENERICFD",
                         "GF", "REAL", "PRIVATE",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "checkpoint=\"no\" prolongation=\"none\"",
                         NULL,
                         9,
                         "J11",
                         "J12",
                         "J13",
                         "J21",
                         "J22",
                         "J23",
                         "J31",
                         "J32",
                         "J33") == 1)
  {
    warn_mixeddim_gfs = "jacobian";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("JACOBIAN2", "GENERICFD", "GENERICFD",
                         "GF", "REAL", "PRIVATE",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "checkpoint=\"no\" prolongation=\"none\"",
                         NULL,
                         18,
                         "dJ111",
                         "dJ112",
                         "dJ113",
                         "dJ122",
                         "dJ123",
                         "dJ133",
                         "dJ211",
                         "dJ212",
                         "dJ213",
                         "dJ222",
                         "dJ223",
                         "dJ233",
                         "dJ311",
                         "dJ312",
                         "dJ313",
                         "dJ322",
                         "dJ323",
                         "dJ333") == 1)
  {
    warn_mixeddim_gfs = "jacobian2";
    warn_mixeddim = 3;
  }


  if (*warn_mixeddim_gfs)
  {
    if (allow_mixeddim_gfs && *allow_mixeddim_gfs)
    {
      CCTK_VWarn (2, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "creating GF group '%s' with different dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
    else
    {
      CCTK_VWarn (0, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "cannot create GF group '%s' with dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
 }

  CCTKi_RegisterFortranWrapper("GenericFD", CCTKi_BindingsFortranWrapperGenericFD);

  return 0;
}

int CactusBindingsVarIndex_GenericFD_Initialise(void)
{
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J11 = CCTK_VarIndex("GenericFD::J11");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J12 = CCTK_VarIndex("GenericFD::J12");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J13 = CCTK_VarIndex("GenericFD::J13");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J21 = CCTK_VarIndex("GenericFD::J21");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J22 = CCTK_VarIndex("GenericFD::J22");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J23 = CCTK_VarIndex("GenericFD::J23");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J31 = CCTK_VarIndex("GenericFD::J31");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J32 = CCTK_VarIndex("GenericFD::J32");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).J33 = CCTK_VarIndex("GenericFD::J33");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ111 = CCTK_VarIndex("GenericFD::dJ111");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ112 = CCTK_VarIndex("GenericFD::dJ112");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ113 = CCTK_VarIndex("GenericFD::dJ113");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ122 = CCTK_VarIndex("GenericFD::dJ122");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ123 = CCTK_VarIndex("GenericFD::dJ123");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ133 = CCTK_VarIndex("GenericFD::dJ133");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ211 = CCTK_VarIndex("GenericFD::dJ211");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ212 = CCTK_VarIndex("GenericFD::dJ212");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ213 = CCTK_VarIndex("GenericFD::dJ213");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ222 = CCTK_VarIndex("GenericFD::dJ222");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ223 = CCTK_VarIndex("GenericFD::dJ223");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ233 = CCTK_VarIndex("GenericFD::dJ233");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ311 = CCTK_VarIndex("GenericFD::dJ311");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ312 = CCTK_VarIndex("GenericFD::dJ312");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ313 = CCTK_VarIndex("GenericFD::dJ313");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ322 = CCTK_VarIndex("GenericFD::dJ322");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ323 = CCTK_VarIndex("GenericFD::dJ323");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dJ333 = CCTK_VarIndex("GenericFD::dJ333");

  return 0;
}
