/*@@
   @file    ML_CCZ4_Helper.c
   @author  Automatically generated by GridFuncStuff.pl
   @desc
            Creates the CCTK variables for thorn ML_CCZ4_Helper
   @enddesc
 @@*/



#include <stddef.h>

#include "ML_CCZ4_Helper/cctk.h"
#include "ML_CCZ4_Helper/cctk_Arguments.h"
#include "cctk_Parameter.h"
#include "cctk_WarnLevel.h"
#include "cctki_Groups.h"
#include "cctki_FortranWrappers.h"
#include "ML_CCZ4_Helper/cctk_ScheduleFunctions.h"

struct CCTK_JOIN_TOKENS(CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN), _struct) CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN);

int CactusBindingsVariables_ML_CCZ4_Helper_Initialise(void);
int CactusBindingsVarIndex_ML_CCZ4_Helper_Initialise(void);
static int CCTKi_BindingsFortranWrapperML_CCZ4_Helper(void *_GH, void *fpointer);

static int CCTKi_BindingsFortranWrapperML_CCZ4_Helper(void *_GH, void *fpointer)
{
  cGH const *const GH = _GH;
  const int _cctk_zero = 0;
  void (*function)(ML_CCZ4_HELPER_C2F_PROTO);
  DECLARE_ML_CCZ4_HELPER_C2F
  INITIALISE_ML_CCZ4_HELPER_C2F
  (void) (_cctk_zero + 0);

  function = (void (*) (ML_CCZ4_HELPER_C2F_PROTO)) fpointer;
  function (PASS_ML_CCZ4_HELPER_C2F (GH));

  return (0);
}

int CactusBindingsVariables_ML_CCZ4_Helper_Initialise(void)
{
  const char * warn_mixeddim_gfs = "";
  int warn_mixeddim = 0;
  const CCTK_INT *allow_mixeddim_gfs;


  allow_mixeddim_gfs = CCTK_ParameterGet ("allow_mixeddim_gfs", "Cactus", 0);





  if (*warn_mixeddim_gfs)
  {
    if (allow_mixeddim_gfs && *allow_mixeddim_gfs)
    {
      CCTK_VWarn (2, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "creating GF group '%s' with different dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
    else
    {
      CCTK_VWarn (0, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "cannot create GF group '%s' with dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
 }

  CCTKi_RegisterFortranWrapper("ML_CCZ4_Helper", CCTKi_BindingsFortranWrapperML_CCZ4_Helper);

  return 0;
}

int CactusBindingsVarIndex_ML_CCZ4_Helper_Initialise(void)
{
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At11 = CCTK_VarIndex("ML_CCZ4::At11");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At11rhs = CCTK_VarIndex("ML_CCZ4::At11rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At12 = CCTK_VarIndex("ML_CCZ4::At12");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At12rhs = CCTK_VarIndex("ML_CCZ4::At12rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At13 = CCTK_VarIndex("ML_CCZ4::At13");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At13rhs = CCTK_VarIndex("ML_CCZ4::At13rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At22 = CCTK_VarIndex("ML_CCZ4::At22");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At22rhs = CCTK_VarIndex("ML_CCZ4::At22rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At23 = CCTK_VarIndex("ML_CCZ4::At23");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At23rhs = CCTK_VarIndex("ML_CCZ4::At23rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At33 = CCTK_VarIndex("ML_CCZ4::At33");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).At33rhs = CCTK_VarIndex("ML_CCZ4::At33rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).B1 = CCTK_VarIndex("ML_CCZ4::B1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).B1rhs = CCTK_VarIndex("ML_CCZ4::B1rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).B2 = CCTK_VarIndex("ML_CCZ4::B2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).B2rhs = CCTK_VarIndex("ML_CCZ4::B2rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).B3 = CCTK_VarIndex("ML_CCZ4::B3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).B3rhs = CCTK_VarIndex("ML_CCZ4::B3rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).H = CCTK_VarIndex("ML_CCZ4::H");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).M1 = CCTK_VarIndex("ML_CCZ4::M1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).M2 = CCTK_VarIndex("ML_CCZ4::M2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).M3 = CCTK_VarIndex("ML_CCZ4::M3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Theta = CCTK_VarIndex("ML_CCZ4::Theta");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Thetarhs = CCTK_VarIndex("ML_CCZ4::Thetarhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Xt1 = CCTK_VarIndex("ML_CCZ4::Xt1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Xt1rhs = CCTK_VarIndex("ML_CCZ4::Xt1rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Xt2 = CCTK_VarIndex("ML_CCZ4::Xt2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Xt2rhs = CCTK_VarIndex("ML_CCZ4::Xt2rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Xt3 = CCTK_VarIndex("ML_CCZ4::Xt3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).Xt3rhs = CCTK_VarIndex("ML_CCZ4::Xt3rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).active_slicing_handle = CCTK_VarIndex("COORDGAUGE::active_slicing_handle");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).alp = CCTK_VarIndex("ADMBASE::alp");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).alpha = CCTK_VarIndex("ML_CCZ4::alpha");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).alpharhs = CCTK_VarIndex("ML_CCZ4::alpharhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).beta1 = CCTK_VarIndex("ML_CCZ4::beta1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).beta1rhs = CCTK_VarIndex("ML_CCZ4::beta1rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).beta2 = CCTK_VarIndex("ML_CCZ4::beta2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).beta2rhs = CCTK_VarIndex("ML_CCZ4::beta2rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).beta3 = CCTK_VarIndex("ML_CCZ4::beta3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).beta3rhs = CCTK_VarIndex("ML_CCZ4::beta3rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betax = CCTK_VarIndex("ADMBASE::betax");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betay = CCTK_VarIndex("ADMBASE::betay");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betaz = CCTK_VarIndex("ADMBASE::betaz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).cA = CCTK_VarIndex("ML_CCZ4::cA");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).cS = CCTK_VarIndex("ML_CCZ4::cS");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).cXt1 = CCTK_VarIndex("ML_CCZ4::cXt1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).cXt2 = CCTK_VarIndex("ML_CCZ4::cXt2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).cXt3 = CCTK_VarIndex("ML_CCZ4::cXt3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).coarse_dx = CCTK_VarIndex("GRID::coarse_dx");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).coarse_dy = CCTK_VarIndex("GRID::coarse_dy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).coarse_dz = CCTK_VarIndex("GRID::coarse_dz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtalp = CCTK_VarIndex("ADMBASE::dtalp");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetax = CCTK_VarIndex("ADMBASE::dtbetax");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetay = CCTK_VarIndex("ADMBASE::dtbetay");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetaz = CCTK_VarIndex("ADMBASE::dtbetaz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtlapse_state = CCTK_VarIndex("ADMBASE::dtlapse_state");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtshift_state = CCTK_VarIndex("ADMBASE::dtshift_state");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt11 = CCTK_VarIndex("ML_CCZ4::gt11");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt11rhs = CCTK_VarIndex("ML_CCZ4::gt11rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt12 = CCTK_VarIndex("ML_CCZ4::gt12");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt12rhs = CCTK_VarIndex("ML_CCZ4::gt12rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt13 = CCTK_VarIndex("ML_CCZ4::gt13");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt13rhs = CCTK_VarIndex("ML_CCZ4::gt13rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt22 = CCTK_VarIndex("ML_CCZ4::gt22");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt22rhs = CCTK_VarIndex("ML_CCZ4::gt22rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt23 = CCTK_VarIndex("ML_CCZ4::gt23");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt23rhs = CCTK_VarIndex("ML_CCZ4::gt23rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt33 = CCTK_VarIndex("ML_CCZ4::gt33");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gt33rhs = CCTK_VarIndex("ML_CCZ4::gt33rhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gxx = CCTK_VarIndex("ADMBASE::gxx");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gxy = CCTK_VarIndex("ADMBASE::gxy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gxz = CCTK_VarIndex("ADMBASE::gxz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gyy = CCTK_VarIndex("ADMBASE::gyy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gyz = CCTK_VarIndex("ADMBASE::gyz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gzz = CCTK_VarIndex("ADMBASE::gzz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kxx = CCTK_VarIndex("ADMBASE::kxx");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kxy = CCTK_VarIndex("ADMBASE::kxy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kxz = CCTK_VarIndex("ADMBASE::kxz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kyy = CCTK_VarIndex("ADMBASE::kyy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kyz = CCTK_VarIndex("ADMBASE::kyz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kzz = CCTK_VarIndex("ADMBASE::kzz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).phi = CCTK_VarIndex("ML_CCZ4::phi");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).phirhs = CCTK_VarIndex("ML_CCZ4::phirhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).r = CCTK_VarIndex("GRID::r");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).shift_state = CCTK_VarIndex("ADMBASE::shift_state");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).trK = CCTK_VarIndex("ML_CCZ4::trK");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).trKrhs = CCTK_VarIndex("ML_CCZ4::trKrhs");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).x = CCTK_VarIndex("GRID::x");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).y = CCTK_VarIndex("GRID::y");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).z = CCTK_VarIndex("GRID::z");

  return 0;
}
