/*@@
   @file    ShiftedGaugeWave.c
   @author  Automatically generated by GridFuncStuff.pl
   @desc
            Creates the CCTK variables for thorn ShiftedGaugeWave
   @enddesc
 @@*/



#include <stddef.h>

#include "ShiftedGaugeWave/cctk.h"
#include "ShiftedGaugeWave/cctk_Arguments.h"
#include "cctk_Parameter.h"
#include "cctk_WarnLevel.h"
#include "cctki_Groups.h"
#include "cctki_FortranWrappers.h"
#include "ShiftedGaugeWave/cctk_ScheduleFunctions.h"

struct CCTK_JOIN_TOKENS(CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN), _struct) CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN);

int CactusBindingsVariables_ShiftedGaugeWave_Initialise(void);
int CactusBindingsVarIndex_ShiftedGaugeWave_Initialise(void);
static int CCTKi_BindingsFortranWrapperShiftedGaugeWave(void *_GH, void *fpointer);

static int CCTKi_BindingsFortranWrapperShiftedGaugeWave(void *_GH, void *fpointer)
{
  cGH const *const GH = _GH;
  const int _cctk_zero = 0;
  void (*function)(SHIFTEDGAUGEWAVE_C2F_PROTO);
  DECLARE_SHIFTEDGAUGEWAVE_C2F
  INITIALISE_SHIFTEDGAUGEWAVE_C2F
  (void) (_cctk_zero + 0);

  function = (void (*) (SHIFTEDGAUGEWAVE_C2F_PROTO)) fpointer;
  function (PASS_SHIFTEDGAUGEWAVE_C2F (GH));

  return (0);
}

int CactusBindingsVariables_ShiftedGaugeWave_Initialise(void)
{
  const char * warn_mixeddim_gfs = "";
  int warn_mixeddim = 0;
  const CCTK_INT *allow_mixeddim_gfs;


  allow_mixeddim_gfs = CCTK_ParameterGet ("allow_mixeddim_gfs", "Cactus", 0);

  if (CCTKi_CreateGroup ("METRIC_EXACT", "SHIFTEDGAUGEWAVE", "SHIFTEDGAUGEWAVE",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"DD_sym\" tensorweight=0",
                         NULL,
                         6,
                         "gExact11",
                         "gExact12",
                         "gExact13",
                         "gExact22",
                         "gExact23",
                         "gExact33") == 1)
  {
    warn_mixeddim_gfs = "metric_exact";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("CURV_EXACT", "SHIFTEDGAUGEWAVE", "SHIFTEDGAUGEWAVE",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"DD_sym\" tensorweight=0",
                         NULL,
                         6,
                         "kExact11",
                         "kExact12",
                         "kExact13",
                         "kExact22",
                         "kExact23",
                         "kExact33") == 1)
  {
    warn_mixeddim_gfs = "curv_exact";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("LAPSE_EXACT", "SHIFTEDGAUGEWAVE", "SHIFTEDGAUGEWAVE",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "alpExact") == 1)
  {
    warn_mixeddim_gfs = "lapse_exact";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("DTLAPSE_EXACT", "SHIFTEDGAUGEWAVE", "SHIFTEDGAUGEWAVE",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"Scalar\" tensorweight=0",
                         NULL,
                         1,
                         "dtalpExact") == 1)
  {
    warn_mixeddim_gfs = "dtlapse_exact";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("SHIFT_EXACT", "SHIFTEDGAUGEWAVE", "SHIFTEDGAUGEWAVE",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0",
                         NULL,
                         3,
                         "betaExact1",
                         "betaExact2",
                         "betaExact3") == 1)
  {
    warn_mixeddim_gfs = "shift_exact";
    warn_mixeddim = 3;
  }
  if (CCTKi_CreateGroup ("DTSHIFT_EXACT", "SHIFTEDGAUGEWAVE", "SHIFTEDGAUGEWAVE",
                         "GF", "REAL", "PUBLIC",
                         3, 1,
                         "DEFAULT",
                         "", "",
                         "tensortypealias=\"U\" tensorweight=0",
                         NULL,
                         3,
                         "dtbetaExact1",
                         "dtbetaExact2",
                         "dtbetaExact3") == 1)
  {
    warn_mixeddim_gfs = "dtshift_exact";
    warn_mixeddim = 3;
  }




  if (*warn_mixeddim_gfs)
  {
    if (allow_mixeddim_gfs && *allow_mixeddim_gfs)
    {
      CCTK_VWarn (2, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "creating GF group '%s' with different dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
    else
    {
      CCTK_VWarn (0, __LINE__, __FILE__, "Cactus",
                  "CCTKi_CreateGroup: Working dimension already set, "
                  "cannot create GF group '%s' with dimension %d",
                  warn_mixeddim_gfs, warn_mixeddim);
    }
 }

  CCTKi_RegisterFortranWrapper("ShiftedGaugeWave", CCTKi_BindingsFortranWrapperShiftedGaugeWave);

  return 0;
}

int CactusBindingsVarIndex_ShiftedGaugeWave_Initialise(void)
{
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).alp = CCTK_VarIndex("ADMBASE::alp");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).alpExact = CCTK_VarIndex("ShiftedGaugeWave::alpExact");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betaExact1 = CCTK_VarIndex("ShiftedGaugeWave::betaExact1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betaExact2 = CCTK_VarIndex("ShiftedGaugeWave::betaExact2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betaExact3 = CCTK_VarIndex("ShiftedGaugeWave::betaExact3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betax = CCTK_VarIndex("ADMBASE::betax");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betay = CCTK_VarIndex("ADMBASE::betay");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).betaz = CCTK_VarIndex("ADMBASE::betaz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).coarse_dx = CCTK_VarIndex("GRID::coarse_dx");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).coarse_dy = CCTK_VarIndex("GRID::coarse_dy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).coarse_dz = CCTK_VarIndex("GRID::coarse_dz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtalp = CCTK_VarIndex("ADMBASE::dtalp");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtalpExact = CCTK_VarIndex("ShiftedGaugeWave::dtalpExact");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetaExact1 = CCTK_VarIndex("ShiftedGaugeWave::dtbetaExact1");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetaExact2 = CCTK_VarIndex("ShiftedGaugeWave::dtbetaExact2");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetaExact3 = CCTK_VarIndex("ShiftedGaugeWave::dtbetaExact3");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetax = CCTK_VarIndex("ADMBASE::dtbetax");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetay = CCTK_VarIndex("ADMBASE::dtbetay");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtbetaz = CCTK_VarIndex("ADMBASE::dtbetaz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtlapse_state = CCTK_VarIndex("ADMBASE::dtlapse_state");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).dtshift_state = CCTK_VarIndex("ADMBASE::dtshift_state");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gExact11 = CCTK_VarIndex("ShiftedGaugeWave::gExact11");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gExact12 = CCTK_VarIndex("ShiftedGaugeWave::gExact12");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gExact13 = CCTK_VarIndex("ShiftedGaugeWave::gExact13");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gExact22 = CCTK_VarIndex("ShiftedGaugeWave::gExact22");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gExact23 = CCTK_VarIndex("ShiftedGaugeWave::gExact23");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gExact33 = CCTK_VarIndex("ShiftedGaugeWave::gExact33");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gxx = CCTK_VarIndex("ADMBASE::gxx");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gxy = CCTK_VarIndex("ADMBASE::gxy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gxz = CCTK_VarIndex("ADMBASE::gxz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gyy = CCTK_VarIndex("ADMBASE::gyy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gyz = CCTK_VarIndex("ADMBASE::gyz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).gzz = CCTK_VarIndex("ADMBASE::gzz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kExact11 = CCTK_VarIndex("ShiftedGaugeWave::kExact11");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kExact12 = CCTK_VarIndex("ShiftedGaugeWave::kExact12");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kExact13 = CCTK_VarIndex("ShiftedGaugeWave::kExact13");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kExact22 = CCTK_VarIndex("ShiftedGaugeWave::kExact22");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kExact23 = CCTK_VarIndex("ShiftedGaugeWave::kExact23");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kExact33 = CCTK_VarIndex("ShiftedGaugeWave::kExact33");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kxx = CCTK_VarIndex("ADMBASE::kxx");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kxy = CCTK_VarIndex("ADMBASE::kxy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kxz = CCTK_VarIndex("ADMBASE::kxz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kyy = CCTK_VarIndex("ADMBASE::kyy");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kyz = CCTK_VarIndex("ADMBASE::kyz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).kzz = CCTK_VarIndex("ADMBASE::kzz");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).r = CCTK_VarIndex("GRID::r");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).shift_state = CCTK_VarIndex("ADMBASE::shift_state");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).x = CCTK_VarIndex("GRID::x");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).y = CCTK_VarIndex("GRID::y");
  CCTK_JOIN_TOKENS(cctki_vi_, CCTK_THORN).z = CCTK_VarIndex("GRID::z");

  return 0;
}
